package com.vendor.burn.serial.workers;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.commands.CrcCommand;
import com.vendor.burn.model.AlgorithmType;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.event.EventType;
import com.vendor.burn.serial.workers.CallLibJTAGWorker;
import com.vendor.burn.serial.workers.PartitionBurnerWorker;
import com.vendor.platform.api.statistics.ToolStatistics;
import java.io.File;
import java.io.IOException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Text;

public class CheckSumBurnerWorker extends PartitionBurnerWorker {
  public CheckSumBurnerWorker(IBurner burner) {
    super(burner);
    this.burner = burner;
  }
  
  public boolean checkSum(IProgressMonitor uiMonitor, File file, boolean call, Text checkSumResultText, AlgorithmType checkSumType) {
    ToolStatistics.INSTANCE.logUsage("BurnTool", "Check Sum", "ChipName: " + this.burner
        .getBurnContext().getDeviceSetting().getName());
    ToolStatistics.INSTANCE.logToolInUse("BurnTool");
    String versionInfo = getVersionInfo("Check Sum");
    CallLibJTAGWorker.printDebugInfo(versionInfo);
    monitor.getEvent().init(EventType.CHECK_SUM);
    if (uiMonitor.isCanceled()) {
      monitor.getEvent().setUserCanceled(true);
      return false;
    } 
    uiMonitor.beginTask("Checking Sum", 100);
    if (uiMonitor.isCanceled()) {
      monitor.getEvent().setUserCanceled(true);
      return false;
    } 
    if (checkSumType == null)
      return false; 
    String result = "";
    try {
      if (checkSumType.equals(AlgorithmType.CUMULATIVE_SUM)) {
        result = Integer.toHexString(CrcCommand.calculateCheckSum(file));
        result = alignByByte(result, 8);
      } else {
        result = Integer.toHexString(CrcCommand.calculateCRC16(file));
        result = alignByByte(result, 4);
      } 
    } catch (IOException iOException) {}
    String resultStr = "0x" + result;
    Display.getDefault().syncExec((Runnable)new Object(this, checkSumResultText, resultStr));
    uiMonitor.worked(100);
    warning("Check Sum Results: " + resultStr + "\n");
    infoln("The Check Sum successfully!");
    return true;
  }
  
  public String alignByByte(String str, int size) {
    StringBuilder sb = new StringBuilder();
    int num = size - str.length();
    if (size - str.length() > 0)
      for (int j = 0; j < num; j++)
        sb.append("0");  
    sb.append(str);
    return sb.toString();
  }
}
